Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/mex.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/mex.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/mex.f	(revision 2696)
@@ -0,0 +1,377 @@
+/* #include <math.h> */
+#include "mex.h"
+#include <stdarg.h>
+
+#define MAX_BUF 200
+
+void Usage()
+{
+  mexPrintf("                                                                    \n"
+            "To get this help message use:                KPP_ROOT ?            \n"
+            "                                                                    \n"
+            "To initialize default values use:            KPP_ROOT              \n"
+            "   (type who to see the variables created)                          \n"
+            "                                                                    \n"
+            "To integrate the model use:                                         \n"
+            "          [ c, m, f ] = KPP_ROOT( t, c0, k, p, fn, tfn );          \n"
+            "                                                                    \n"
+            "  input :                                                           \n"
+            "         t   - Time vector, contains the time at which results      \n" 
+            "               should be reported;                                  \n"
+            "         c0  - Vector with the initial concentrations for all       \n"
+            "               species;                                             \n"
+            "         k   - Vector with all rate constants;                      \n"
+            "         p   - Vector of parameters for the integration;            \n"
+            "                 p(1) holds the relative tolerance                  \n"
+            "                 p(2) holds the absolute tolerance                  \n"
+            "                 p(3) holds the minimum step size allowed           \n"
+            "                 p(4) holds the maximum step size allowed           \n"
+            "               If any of the above is zero the default value is     \n"
+            "               used;                                                \n"
+            "         fn  - (optional) Name of a matlab function to be called    \n"
+            "               to update the values of k's and concentrations       \n"                   
+            "               If not present no update is performed.               \n"
+            "                                                                    \n"
+            "         tfn - (optional) Time at which the fn function should      \n"
+            "               be called. If missing <t> is assumed.                \n"
+            "                                                                    \n"
+            "  output:                                                           \n"
+            "         c   - Matrix of concentrations of all species vs. time;    \n"
+            "         m   - (optional) Mass conservation of all atoms vs. time;  \n"
+            "         f   - (optional) Matrix of fluxes of all species vs. time; \n"
+            "                                                                    \n"
+           );
+}
+
+int giveusage;
+
+void F9Error( char *fmt, ... )
+{
+va_list args;
+char buf[ MAX_BUF ];
+char errmsg[ MAX_BUF ];
+
+  va_start( args, fmt );
+  vsprintf( buf, fmt, args );
+  va_end( args );
+  
+  if( giveusage ) Usage();
+  
+  mexPrintf("Error: %s\n", buf);  
+  mexErrMsgTxt( 0 );
+}
+
+char allvars[1000];
+
+int CreateVar(char *name, KPP_REAL val)
+{
+mxArray *GA;
+double  *pga;
+
+  sprintf(allvars, "%s %s",allvars, name);
+  GA = mxCreateDoubleMatrix(1,1,mxREAL);
+  pga = mxGetPr(GA);
+  *pga = (double)val;
+  mxSetName(GA,name);
+  return mexPutArray(GA,"global");
+}
+
+int CreateVec(char *name, int len, KPP_REAL *val)
+{
+mxArray *GA;
+double  *pga;
+int i;
+
+  sprintf(allvars, "%s %s",allvars, name);
+  GA = mxCreateDoubleMatrix(1,len,mxREAL);
+  pga = mxGetPr(GA);
+  if( sizeof(KPP_REAL) == sizeof(double) ) {
+    memmove( pga, val, len*sizeof(double) );
+  } else {
+    for( i = 0; i < len; i++ ) pga[i] = (double)val[i];
+  }   
+  mxSetName(GA,name);
+  return mexPutArray(GA,"global");
+}
+
+int CreateStrVec(char *name, int len, char **val)
+{
+mxArray *GA;
+
+  sprintf(allvars, "%s %s",allvars, name);
+  GA = mxCreateCharMatrixFromStrings( len, (const char **)val );
+  mxSetName(GA,name);
+  return mexPutArray(GA,"global");
+}
+
+int CreateStr(char *name, char *val)
+{
+mxArray *GA;
+
+  sprintf(allvars, "%s %s",allvars, name);
+  GA = mxCreateString( val );
+  mxSetName(GA,name);
+  return mexPutArray(GA,"global");
+}
+
+#define	  T_PRM	          prhs[0]
+#define  C0_PRM           prhs[1]
+#define   K_PRM           prhs[2]
+#define   P_PRM           prhs[3]
+#define  FN_PRM           prhs[4]
+#define TFN_PRM           prhs[5]
+
+#define	  C_PRM	          plhs[0]
+#define	  M_PRM	          plhs[1]
+#define	  F_PRM	          plhs[2]
+
+#define  HAS_FN           (nrhs >= 5)
+#define  HAS_TFN          (nrhs >= 6)
+
+#define  HAS_M            (nlhs >= 2)
+#define  HAS_F            (nlhs >= 3)
+
+#define  DBL  (sizeof(KPP_REAL) == sizeof(double))
+
+void mexFunction(
+                 int nlhs,       mxArray *plhs[],
+                 int nrhs, const mxArray *prhs[]
+		 )
+{
+double *  tp; 
+double * c0p;
+double *  kp;
+double *  pp;
+char     fnp[ MAX_BUF ];
+double *tfnp;
+
+double *  cp;
+double *  mp;
+double *  fp;
+double ATOLS;
+double  dval[ NMASS+NSPEC ];
+
+mxArray *Carr, *Karr, *Tarr;
+double  *fcp;
+double  *fkp;
+double  *ftp, *ftp1;
+
+int i,j,m,n,nd,t;
+int nsteps, nspc, nreact, ncb;
+int tcb, CallBack;
+KPP_REAL prm[4];
+
+  giveusage = 1;
+
+  if(nrhs == 0) {
+
+    InitVal();
+    Update_RCONST();
+    
+    prm[0] = 1e-4; 
+    prm[1] = 1.0E-18;
+    prm[2] = 0.01;
+    prm[3] = 900;
+
+    sprintf(allvars,"global ");
+    
+    CreateVec("PRM",4, prm);
+    
+    CreateVar("NSPEC",NSPEC);
+    CreateVar("NREACT",NREACT);
+    CreateVar("NMASS",NMASS);
+ 
+    CreateVec("C0", NSPEC, C);
+    CreateVec("K0", NREACT, RCONST);
+
+    for( i = 0; i < NLOOKAT; i++ )  
+      CreateVar( SLOOKAT[i], (double)(i+1) );
+    
+    for( i = 0; i < NMASS; i++ )  
+      CreateVar( SMASS[i], (double)(i+1) );
+
+    CreateStrVec("SSPEC", NSPEC, SLOOKAT);
+    CreateStrVec("SMASS", NMASS, SMASS);
+    CreateStrVec("SEQN", NREACT, SEQN);
+
+    CreateStr("GLOBALCMD", allvars);
+ 
+    mexEvalString(allvars);
+/*
+    mexPrintf("The KPP_ROOT model parameters were sucessfully initialized.\n");    
+*/
+    return;
+  }
+
+  if( nrhs < 4 ) 
+    F9Error("First 4 parameters are REQUIRED only %d received.", nrhs);
+  if( nlhs < 1 ) 
+    F9Error("At least one output parameter REQUIRED.");
+
+  if(! mxIsDouble(T_PRM))   F9Error("<t> must be of type double.");
+  if(! mxIsDouble(C0_PRM))  F9Error("<c0> must be of type double."); 
+  if(! mxIsDouble(K_PRM))   F9Error("<k> must be of type double.");
+  if(! mxIsDouble(P_PRM))   F9Error("<p> must be of type double.");
+  if((nrhs > 4) && (! mxIsChar(FN_PRM))) F9Error("<fn> must be of type char.");     
+  if((nrhs > 5) && (! mxIsDouble(TFN_PRM))) F9Error("<tfn> must be of type double.");     
+      
+  nd = mxGetNumberOfDimensions( T_PRM );
+  m  =                  mxGetM( T_PRM ); 
+  n  =                  mxGetN( T_PRM );    
+  if( !( (nd == 2) && ((m == 1) || (n == 1)) ) ) F9Error("<t> must be a column vector.");
+  nsteps = (m == 1) ? n : m;
+  tp = mxGetPr( T_PRM );  
+
+  nd = mxGetNumberOfDimensions( C0_PRM );
+  m  =                  mxGetM( C0_PRM ); 
+  n  =                  mxGetN( C0_PRM );    
+  if( !( (nd == 2) && ((m == 1) || (n == 1)) ) ) F9Error("<c0> must be a column vector.");
+  nspc = (m == 1) ? n : m;
+  c0p = mxGetPr( C0_PRM );  
+
+  nd = mxGetNumberOfDimensions( K_PRM );
+  m  =                  mxGetM( K_PRM ); 
+  n  =                  mxGetN( K_PRM );    
+  if( !( (nd == 2) && ((m == 1) || (n == 1)) ) ) F9Error("<k> must be a column vector.");
+  nreact = (m == 1) ? n : m;
+  kp = mxGetPr( K_PRM );  
+
+  nd = mxGetNumberOfDimensions( P_PRM );
+  m  =                  mxGetM( P_PRM ); 
+  n  =                  mxGetN( P_PRM );    
+  if( !( (nd == 2) && ((m == 1) || (n == 1)) && (n*m == 4) ) ) 
+    F9Error("<p> must be a column vectorof length 4.");
+  pp = mxGetPr( P_PRM );  
+
+  *fnp = 0;
+  if( HAS_FN ) {
+    nd = mxGetNumberOfDimensions( FN_PRM );
+    m  =                  mxGetM( FN_PRM ); 
+    n  =                  mxGetN( FN_PRM );    
+    if( !( (nd == 2) && ((m == 1) || (n == 1)) ) ) F9Error("<fn> must be a character string.");
+    if( mxGetString( FN_PRM, fnp, MAX_BUF ) ) 
+      F9Error("Can not read function mane (too long?)");  
+
+    Carr = mxCreateDoubleMatrix(1,NSPEC,mxREAL);
+    fcp = mxGetPr(Carr);
+    mxSetName(Carr,"C");
+    mexPutArray(Carr,"base");
+    
+    Karr = mxCreateDoubleMatrix(1,NREACT,mxREAL);
+    fkp = mxGetPr(Karr);
+    mxSetName(Karr,"K");
+    mexPutArray(Karr,"base");
+    
+    Tarr = mxCreateDoubleMatrix(1,1,mxREAL);
+    ftp = mxGetPr(Tarr);
+    mxSetName(Tarr,"T");
+    mexPutArray(Tarr,"base");
+  }
+
+  tfnp = 0; ncb = 0;
+  if( HAS_TFN ) {
+    nd = mxGetNumberOfDimensions( TFN_PRM );
+    m  =                  mxGetM( TFN_PRM ); 
+    n  =                  mxGetN( TFN_PRM );    
+    if( !( (nd == 2) && ((m == 1) || (n == 1)) ) ) F9Error("<tfn> must be a column vector.");
+    ncb = (m == 1) ? n : m; 
+    tfnp = mxGetPr( TFN_PRM );
+  }
+
+  giveusage = 0;
+
+  if( !((nspc == NSPEC) && (nreact == NREACT)) ) {
+    F9Error("Size of parameters do not match the model:\n\n"
+            "  Number of species was %d and should be %d;\n"             
+            "  Number of rections (rate constants) was %d and should be %d;\n",
+            nspc, NSPEC, nreact, NREACT);    
+  }
+
+  if( DBL ) { memmove( C, c0p, sizeof(double)*NSPEC );
+              memmove( RCONST, kp, sizeof(double)*NREACT ); }
+       else { for( i = 0; i < NSPEC; i++ ) C[i] = (KPP_REAL)c0p[i];
+              for( i = 0; i < NREACT; i++ ) RCONST[i] = (KPP_REAL)kp[i]; }
+  
+  RTOLS = 1e-4;
+  ATOLS = 1e-18;
+  STEPMIN = 0.01;
+  STEPMAX = 900.0;
+          
+  if( pp[0] ) RTOLS = pp[0];
+  if( pp[1] ) ATOLS = pp[1];
+  if( pp[2] ) STEPMIN = pp[2];
+  if( pp[3] ) STEPMAX = pp[3];
+  
+  for( i = 0; i < NVAR; i++ ) {
+    RTOL[i] = RTOLS;
+    ATOL[i] = ATOLS;
+  }
+  
+  C_PRM = mxCreateDoubleMatrix(NSPEC,nsteps,mxREAL); 
+  cp = mxGetPr(C_PRM);
+  
+  if( HAS_M ) {
+    M_PRM = mxCreateDoubleMatrix(NMASS,nsteps,mxREAL);
+    mp = mxGetPr(M_PRM);
+  }
+  
+  if( HAS_F ) {
+    F_PRM = mxCreateDoubleMatrix(NSPEC,nsteps,mxREAL);
+    fp = mxGetPr(F_PRM);
+  }
+
+  tcb = 0;
+
+  for( t = 0; t < nsteps; t++ ) {              
+    if( t ) {
+      TIME = tp[t-1];
+
+      CallBack = 0;
+      if( HAS_TFN ) {
+        if( tcb < ncb )
+          if( tfnp[tcb] <= TIME ) { CallBack = 1; tcb++; }
+      } else {
+        CallBack = HAS_FN;
+      } 
+
+      if( CallBack ) {
+        if( DBL ) { memmove( fcp, C, sizeof(double)*NSPEC ); 
+                    memmove( fkp, RCONST, sizeof(double)*NREACT ); }
+             else { for( i = 0; i < NSPEC; i++ ) fcp[i] = (double)C[i]; 
+                    for( i = 0; i < NREACT; i++ ) fkp[i] = (double)RCONST[i]; }
+        *ftp = TIME; 
+
+        mexPutArray(Carr,"base");
+        mexPutArray(Karr,"base");
+        mexPutArray(Tarr,"base");
+
+        mexCallMATLAB( 0, 0, 0, 0, fnp );
+
+        mxDestroyArray(Carr); Carr = mexGetArray("C","base"); fcp = mxGetPr(Carr);
+        mxDestroyArray(Karr); Karr = mexGetArray("K","base"); fkp = mxGetPr(Karr);
+        mxDestroyArray(Tarr); Tarr = mexGetArray("T","base"); ftp = mxGetPr(Tarr);
+
+        if( DBL ) { memmove( C, fcp, sizeof(double)*NSPEC ); 
+                    memmove( RCONST, fkp, sizeof(double)*NREACT ); }
+             else { for( i = 0; i < NSPEC; i++ ) C[i] = (KPP_REAL)fcp[i]; 
+                    for( i = 0; i < NREACT; i++ ) RCONST[i] = (KPP_REAL)fkp[i]; }
+ 
+      }
+
+      INTEGRATE( tp[t-1], tp[t] );
+    }
+    if( DBL ) { memmove( cp, C, sizeof(double)*NSPEC ); cp += NSPEC; } 
+         else { for( i = 0; i < NSPEC; i++ ) *cp++ = (double)C[i]; }
+    if( HAS_M ) {
+      if( DBL ) { GetMass( mp ); mp += NMASS; } 
+           else { GetMass( dval );
+                  for( i = 0; i < NMASS; i++ ) *mp++ = (double)dval[i]; }
+    }
+    if( HAS_F ) {
+      if( DBL ) { FLUX( fp ); fp += NSPEC; }
+           else { FLUX( dval );
+                  for( i = 0; i < NSPEC; i++ ) *fp++ = (double)dval[i]; }           
+    }
+  }
+}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/ncar.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/ncar.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/ncar.c	(revision 2696)
@@ -0,0 +1,295 @@
+#include <stdio.h>
+#include <math.h>
+#include <ctype.h>
+#include <ncarg/ncargC.h>
+#include <ncarg/gks.h>
+#include "ncar.h"
+
+#define MAX_COLORS 9
+#define MAX_GRAPHS 8 
+#define WS_ID 1
+
+Grgb colors[] = {{ 0.0, 0.0, 0.0 },
+		 { 1.0, 1.0, 1.0 },
+		 { 0.0, 1.0, 0.0 },
+                 { 1.0, 1.0, 0.0 },
+                 { 0.0, 1.0, 1.0 }, 
+		 { 1.0, 0.4, 0.4 },
+                 { 1.0, 0.0, 1.0 }, 
+		 { 0.7, 1.0, 0.7 },
+		 { 0.5, 0.5, 1.0 }
+		};
+
+
+int nGraphs = 0;
+int nMax;
+int nCrt;
+int CrtGraph;
+
+char *graphName[ MAX_GRAPHS ];
+char *graphTitle;
+char * startMsg = "Working... Press CTRL-C to stop";
+char * endMsg   = "DONE ! Press <ENTER> when ready.";
+char * status = "S";
+
+float * Xval;
+float * Yval;
+float * scale;
+float * offset;
+float ch;
+
+float XminGraph, XmaxGraph;
+float Ybottom[ MAX_GRAPHS ];
+float Ytop[ MAX_GRAPHS ];
+float Ymin[ MAX_GRAPHS ];
+float Ymax[ MAX_GRAPHS ];
+float Ybase[ MAX_GRAPHS ];
+
+int crtState;
+int clean = 0;
+
+void Boundary();
+
+void OpenWin()
+{
+int i;
+Gcolr_rep colr;		
+
+  gopen_gks( "stdout", 0 );
+  gopen_ws( WS_ID, (char*)0, 8 );
+  gactivate_ws( WS_ID );
+   
+  for( i = 0; i < MAX_COLORS; i++ ) {
+    colr.rgb.red = colors[i].red;
+    colr.rgb.green = colors[i].green;
+    colr.rgb.blue = colors[i].blue;
+    gset_colr_rep( 1, i, &colr );
+  }  
+}
+
+
+int DefineGraph( char * label, float min, float max )
+{
+  graphName[ nGraphs ] = label;
+  Ymin[ nGraphs ] = min;
+  Ymax[ nGraphs ] = max;
+  nGraphs++;
+  return nGraphs;   
+}
+
+void SelectGraph( int i ) 
+{
+  CrtGraph = i;
+  
+  c_agsetf("GRID/BOTTOM.", Ybottom[i]);
+  c_agsetf("GRID/TOP."   , Ytop[i]);
+
+  c_agsetf("Y/MINIMUM.", Ymin[i]);
+  c_agsetf("Y/MAXIMUM.", Ymax[i]);
+/*
+  c_agsetf("LEFT/MAJOR/BASE.", Ybase[i] );   
+*/
+  if( i == 0 ) 
+    c_agsetf("BOTTOM/TYPE.", 3); 
+  else
+    c_agsetf("BOTTOM/TYPE.", 0);
+}
+
+void InitGraph( int n, float Xmin, float Xmax, char *title )
+{
+int i;
+float step;
+char buf[100];
+
+  nMax = n;
+  n = n + 1;
+  XminGraph = Xmin;
+  XmaxGraph = Xmax;
+  graphTitle = title;
+  
+  step = (Xmax - Xmin) / nMax;
+
+  Xval = (float*)malloc( n * sizeof(float) );
+  for( i = 0; i < n; i++ )
+    Xval[i] = Xmin + step*i;
+
+  Yval = (float*)malloc( nGraphs * n * sizeof(float) );
+  for( i = 0; i < nGraphs * n; i++ )
+    Yval[i] = NULL/1;
+
+  c_agseti("WINDOWING.",1);
+  c_agseti("FRAME.", 2 );
+  c_agseti("BACKGROUND.", 3 );
+
+  c_agsetf("GRID/LEFT."  ,.15);
+  c_agsetf("GRID/RIGHT." ,.90);
+  
+  for( i = 0; i < nGraphs; i++ ) {
+    Ybottom[i] = .08 + 0.02 + i*0.84/nGraphs;
+    Ytop[i] = .08 - 0.02 + (i+1)*0.84/nGraphs;
+  }  
+  ch = (Ytop[0] - Ybottom[0]);
+  ch = .02/ch;
+
+  c_agsetf("X/MINIMUM.", Xmin);
+  c_agsetf("X/MAXIMUM.", Xmax);
+
+  c_agsetc("LABEL/NAME.","T");
+  c_agseti("LINE/NUMBER.",100);
+  c_agsetf("LINE/CH.", 0.1 );
+
+  c_agsetc("LABEL/NAME.","B");
+  c_agseti("LINE/NUMBER.",-100);
+  c_agsetc("LINE/TEXT.", " " );
+
+  c_agsetf("BOTTOM/MAJOR/OUTWARD.", .02 ); 
+  c_agsetf("BOTTOM/WIDTH/MA.", 0.20 );
+  c_agsetf("BOTTOM/WIDTH/EX.", 0.15 );
+
+  c_agsetc("LABEL/NAME.","L");
+  c_agseti("LINE/NUMBER.",100);
+  c_agsetc("LINE/TEXT.", " " );
+
+  c_agseti("LEFT/MAJOR/TYPE.", 1 );
+  c_agsetf("LEFT/MAJOR/OUTWARD.", .02 ); 
+  c_agseti("LEFT/MINOR/SPACING.",4);
+  c_agsetf("LEFT/WIDTH/MA.", .7*ch );
+  c_agsetf("LEFT/WIDTH/EX.", .5*ch );
+  
+  c_agsetc("LABEL/NAME.", status );
+  c_agsetf("LABEL/BASEPOINT/X.", 0.5);
+  c_agsetf("LABEL/BASEPOINT/Y.", 1+2*ch);
+  c_agseti("LABEL/ANGLE.", 0);
+  c_agseti("LINE/NUMBER.", 0);
+  c_agsetc("LINE/TEXT.", startMsg );
+  c_agsetf("LINE/CH.", ch );      
+
+  Boundary();
+}
+
+float Round( float x )
+{
+float p;
+ 
+  if( x == 0 ) return x;
+  p = (float)pow( 10.0, -3.0 + (int)(.5+log10( (double)x ) ) );
+  return p * (int)(.5 + x/p); 
+}
+
+
+void UpdateGraph( float * val )
+{
+int i, j, n;
+static int init = 1;
+Gint err, oldcolor;
+int start;
+float v;
+
+  if( nCrt >= nMax ) return;
+  n = nMax+1; 
+
+  for( i = 0; i < nGraphs; i++ )
+    Yval[i*n+nCrt] = val[i];
+  nCrt++;
+
+  start = nGraphs-1;
+  
+  if( init ) {
+    init = 0;
+    ginq_text_colr_ind( &err, &oldcolor );
+
+    c_pcloqu( 0.9, 0.03 , "TIME [hours]", -0.9, 0, 0 );
+    c_pcloqu( 0.08,0.93, "CONC [ppb]", -0.8, 0, 0 );
+      
+    for( i = 0; i < nGraphs; i++ ) {
+      v = val[i] == 0 ? .001 : val[i];  
+      Ymin[i] = Round( v * (1 - Ymin[i]) );
+      Ymax[i] = Round( v * (1 + Ymax[i]) );
+/*
+      Ybase[i] = Round((Ymax[i] - Ymin[i])/2);
+      Ymin[i] = Ybase[i]*(int)(.5 + Ymin[i]/Ybase[i]);
+      Ymax[i] = Ymin[i]+2*Ybase[i];
+*/
+      gset_text_colr_ind( i % MAX_COLORS + 2 );
+      c_pcloqu( .86, Ytop[i]-0.01, graphName[i], -1.2, 0, -1 );
+    }
+    gupd_ws( WS_ID, GUPD_PEND );
+
+    gset_text_colr_ind( oldcolor );
+
+    SelectGraph(start);
+    c_ezxy ( Xval, &Yval[start*n], nCrt, "" );  
+    c_agsetc("LABEL/NAME.", status );
+    c_agsetf("LABEL/SU.", 1.);
+    start--;
+  }
+  
+  for( i = start; i >=0; i-- ) {
+    SelectGraph( i );
+    c_ezxy ( Xval, &Yval[i*n], nCrt, "" );  
+  }    
+}
+
+void CloseWin()
+{
+  c_agsetc("LABEL/NAME.", status );
+  c_agsetf("LABEL/SU.", 0. );
+  
+  clean = 1;
+  SelectGraph( nGraphs - 1 );
+  c_ezxy ( Xval, &Yval[(nGraphs - 1)*(nMax+1)], nCrt, "" );   
+  clean = 0;
+
+  c_agsetc("LABEL/NAME.", status );
+  c_agseti("LINE/NUMBER.", 0);
+  c_agsetc("LINE/TEXT.", endMsg );
+
+  c_ezxy ( Xval, &Yval[(nGraphs - 1)*(nMax+1)], nCrt, "" );   
+
+  getchar();
+  c_clsgks();
+}
+
+void Boundary()
+{
+  c_plotif(    0,    0,0);
+  c_plotif(32767,    0,1);
+  c_plotif(32767,32767,1);
+  c_plotif(    0,32767,1);
+  c_plotif(    0,    0,1);
+}
+
+
+void agchcu( int * iflag, int * n )
+{
+  c_plotif( 0., 0., 2 );
+  if( *iflag == 0 ) 
+    gset_line_colr_ind( CrtGraph % MAX_COLORS + 2 );
+  else 
+    gset_line_colr_ind( 1 );
+}
+
+int CmpLabelName( char * s1, char * s2 ) 
+{
+  while ( isspace( *s1 ) ) s1++;
+  while( *s1 == *s2 ) {
+    s1++; s2++;
+  }  
+  if( *s2 == '\0' )
+    return 1;
+  return 0;  
+}
+
+
+void agchil( int * iflag, char * lname, int * lnum ) 
+{
+  c_plotif( 0., 0., 2 );
+  switch( *iflag ) {
+    case 0:
+            if( CmpLabelName( lname, status ) )
+              gset_text_colr_ind( 1 - clean );
+    	    break;
+    case 1: gset_text_colr_ind( 1 );
+            break;
+  }          
+}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/ncar.h
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/ncar.h	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/ncar.h	(revision 2696)
@@ -0,0 +1,5 @@
+void OpenWin();
+void CloseWin();
+int DefineGraph( char * label, float plus, float minus );
+void InitGraph( int n, float Xmin, float Xmax, char *title );
+void UpdateGraph( float * val );
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sparsity_plots.m
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sparsity_plots.m	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sparsity_plots.m	(revision 2696)
@@ -0,0 +1,46 @@
+% Plots the sparsity patterns of the  Jacobian and the Hessian
+
+%%%%% JACOBIAN
+figure(1);
+
+J = zeros(NVAR,NVAR);
+for k=1:LU_NONZERO
+  J( LU_IROW(k), LU_ICOL(k) ) = 1;
+end
+spy(J);
+TK = floor( linspace(1,NVAR,5) );
+set(gca,'XTick',TK,'YTick',TK,'FontSize',14,'LineWidth',2);
+
+%%%%% HESSIAN
+figure(2);
+
+H = zeros(NVAR,NVAR,NVAR);
+for k=1:NHESS
+  H( IHESS_I(k), IHESS_J(k), IHESS_K(k) ) = 1;
+  H( IHESS_I(k), IHESS_K(k), IHESS_J(k) ) = 1;
+end
+
+M = ceil( sqrt(NVAR) );
+
+for i=1:M
+  for j=1:M
+    k = M*(i-1)+j;
+    if ( k <= NVAR )
+      subplot(M,M,k);
+      hold on
+      G = reshape( H(k,1:NVAR,1:NVAR), NVAR, NVAR );
+      % spy(G); figure;hold on
+      for iH=1:NVAR; for jH=1:NVAR
+         if( G(iH, jH) )
+	    plot(iH,NVAR+1-jH,'.'); 
+	 end;
+      end; end
+      text(NVAR/6,NVAR*0.6,int2str(k))
+      set(gca,'XLim',[1,NVAR],'YLim',[1,NVAR]);
+      set(gca,'XTick',[],'YTick',[]);
+      axis('square');
+      box on     
+      hold off;
+    end
+  end
+end    
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.c	(revision 2696)
@@ -0,0 +1,90 @@
+
+int KppDecomp( KPP_REAL *JVS )
+{
+KPP_REAL W[KPP_NVAR];
+KPP_REAL a;
+int k, kk, j, jj;
+
+  for( k = 0; k < KPP_NVAR; k++ ) {
+    if( JVS[ LU_DIAG[k] ] == 0.0 ) return k+1;
+    for( kk = LU_CROW[k]; kk < LU_CROW[k+1]; kk++ )
+      W[ LU_ICOL[kk] ] = JVS[kk];
+    for( kk = LU_CROW[k]; kk < LU_DIAG[k]; kk++ ) {
+      j = LU_ICOL[kk];
+      a = -W[j] / JVS[ LU_DIAG[j] ];
+      W[j] = -a;
+      for( jj = LU_DIAG[j]+1; jj < LU_CROW[j+1]; jj++ )
+        W[ LU_ICOL[jj] ] += a*JVS[jj];
+    }
+    for( kk = LU_CROW[k]; kk < LU_CROW[k+1]; kk++ )
+      JVS[kk] = W[ LU_ICOL[kk] ];
+  }
+  return 0;
+}
+
+/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	Sparse LU factorization, complex
+  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
+int KppDecompCmplxR( KPP_REAL JVSR[], KPP_REAL JVSI[] )
+{
+   KPP_REAL WR[NVAR], WI[NVAR];
+   KPP_REAL ar, ai, den;
+   int k, kk, j, jj;
+
+   for( k = 0; k < NVAR; k++ ) {
+	if( JVSR[ LU_DIAG[k] ] == 0.0 ) return k+1;
+	if( JVSI[ LU_DIAG[k] ] == 0.0 ) return k+1;
+	for( kk = LU_CROW[k]; kk < LU_CROW[k+1]; kk++ ) {
+		WR[ LU_ICOL[kk] ] = JVSR[kk];
+		WI[ LU_ICOL[kk] ] = JVSI[kk];
+	}
+	for( kk = LU_CROW[k]; kk < LU_DIAG[k]; kk++ ) {
+	   j = LU_ICOL[kk];
+	   den = JVSR[LU_DIAG[j]]*JVSR[LU_DIAG[j]] + JVSI[LU_DIAG[j]]*JVSI[LU_DIAG[j]];
+	   ar = -(WR[j]*JVSR[LU_DIAG[j]] + WI[j]*JVSI[LU_DIAG[j]])/den;
+	   ai = -(WI[j]*JVSR[LU_DIAG[j]] - WR[j]*JVSI[LU_DIAG[j]])/den;
+	   WR[j] = -ar;
+	   WI[j] = -ai;
+	   for( jj = LU_DIAG[j]+1; jj < LU_CROW[j+1]; jj++ ) {
+		   WR[ LU_ICOL[jj] ] = WR[ LU_ICOL[jj] ] + ar*JVSR[jj] - ai*JVSI[jj];
+		   WI[ LU_ICOL[jj] ] = WI[ LU_ICOL[jj] ] + ar*JVSI[jj] + ai*JVSR[jj];
+	   }
+	}
+	for( kk = LU_CROW[k]; kk < LU_CROW[k+1]; kk++ ) {
+	   JVSR[kk] = WR[ LU_ICOL[kk] ];
+	   JVSI[kk] = WI[ LU_ICOL[kk] ];
+	}
+   }
+   return 0;
+}
+
+/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	Complex sparse solve subroutine using indirect addressing
+  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
+void KppSolveCmplxR(KPP_REAL JVSR[], KPP_REAL JVSI[], KPP_REAL XR[], KPP_REAL XI[])
+{
+   int i, j;
+   KPP_REAL sumr, sumi, den;
+
+   for ( i = 0; i < NVAR; i++ ) {
+	for ( j = LU_CROW[i]; j < LU_DIAG[i]; j++ ) {
+	   XR[i] = XR[i] - (JVSR[j]*XR[LU_ICOL[j]] - JVSI[j]*XI[LU_ICOL[j]]);
+	   XI[i] = XI[i] - (JVSR[j]*XI[LU_ICOL[j]] + JVSI[j]*XR[LU_ICOL[j]]);
+	}
+   }
+   
+   for ( i = NVAR-1; i >= 0; i-- ) {
+	sumr = XR[i];
+	sumi = XI[i];
+	for ( j = LU_DIAG[i]+1; j < LU_CROW[i+1]; j++) {
+	   sumr = sumr - (JVSR[j]*XR[LU_ICOL[j]] - JVSI[j]*XI[LU_ICOL[j]]);
+	   sumi = sumi - (JVSR[j]*XI[LU_ICOL[j]] + JVSI[j]*XR[LU_ICOL[j]]);
+	}
+	den = JVSR[LU_DIAG[i]]*JVSR[LU_DIAG[i]] + JVSI[LU_DIAG[i]]*JVSI[LU_DIAG[i]];
+  	XR[i] = (sumr*JVSR[LU_DIAG[i]] + sumi*JVSI[LU_DIAG[i]])/den; 
+  	XI[i] = (sumi*JVSR[LU_DIAG[i]] - sumr*JVSI[LU_DIAG[i]])/den;
+   }
+}
+/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	END FUNCTION KppSolveCmplxR
+  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.f	(revision 2696)
@@ -0,0 +1,131 @@
+
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      SUBROUTINE KppDecomp( JVS, IER )
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+C        Sparse LU factorization
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Sparse.h'
+
+      INTEGER  IER
+      KPP_REAL JVS(KPP_LU_NONZERO), W(KPP_NVAR)
+      INTEGER  k, kk, j, jj
+      KPP_REAL a 
+
+      IER = 0
+      DO k=1,NVAR
+        IF ( JVS( LU_DIAG(k) ) .EQ. 0. ) THEN
+            IER = k
+            RETURN
+        END IF
+        DO kk = LU_CROW(k), LU_CROW(k+1)-1
+              W( LU_ICOL(kk) ) = JVS(kk)
+        END DO
+        DO kk = LU_CROW(k), LU_DIAG(k)-1
+            j = LU_ICOL(kk)
+            a = -W(j) / JVS( LU_DIAG(j) )
+            W(j) = -a
+            DO jj = LU_DIAG(j)+1, LU_CROW(j+1)-1
+               W( LU_ICOL(jj) ) = W( LU_ICOL(jj) ) + a*JVS(jj)
+            END DO
+         END DO
+         DO kk = LU_CROW(k), LU_CROW(k+1)-1
+            JVS(kk) = W( LU_ICOL(kk) )
+         END DO
+      END DO
+      RETURN
+      END
+
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      SUBROUTINE KppDecompCmplx( JVS, IER )
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+C        Sparse LU factorization, complex
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Sparse.h'
+
+      INTEGER  IER
+      DOUBLE COMPLEX JVS(KPP_LU_NONZERO), W(KPP_NVAR), a
+      INTEGER  k, kk, j, jj
+
+      IER = 0
+      DO k=1,NVAR
+        IF ( JVS( LU_DIAG(k) ) .EQ. 0. ) THEN
+            IER = k
+            RETURN
+        END IF
+        DO kk = LU_CROW(k), LU_CROW(k+1)-1
+              W( LU_ICOL(kk) ) = JVS(kk)
+        END DO
+        DO kk = LU_CROW(k), LU_DIAG(k)-1
+            j = LU_ICOL(kk)
+            a = -W(j) / JVS( LU_DIAG(j) )
+            W(j) = -a
+            DO jj = LU_DIAG(j)+1, LU_CROW(j+1)-1
+               W( LU_ICOL(jj) ) = W( LU_ICOL(jj) ) + a*JVS(jj)
+            END DO
+         END DO
+         DO kk = LU_CROW(k), LU_CROW(k+1)-1
+            JVS(kk) = W( LU_ICOL(kk) )
+         END DO
+      END DO
+      RETURN
+      END
+
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      SUBROUTINE KppSolveIndirect( JVS, X )
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+C        Sparse solve subroutine using indirect addressing
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Sparse.h'
+
+      INTEGER i, j
+      KPP_REAL JVS(KPP_LU_NONZERO), X(KPP_NVAR), sum
+
+      DO i=1,NVAR
+         DO j = LU_CROW(i), LU_DIAG(i)-1 
+             X(i) = X(i) - JVS(j)*X(LU_ICOL(j));
+	 END DO  
+      END DO
+
+      DO i=NVAR,1,-1
+        sum = X(i);
+        DO j = LU_DIAG(i)+1, LU_CROW(i+1)-1
+          sum = sum - JVS(j)*X(LU_ICOL(j));
+	END DO
+        X(i) = sum/JVS(LU_DIAG(i));
+      END DO
+      
+      RETURN
+      END
+
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      SUBROUTINE KppSolveCmplx( JVS, X )
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+C        Complex sparse solve subroutine using indirect addressing
+C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Sparse.h'
+
+      INTEGER i, j
+      DOUBLE COMPLEX JVS(KPP_LU_NONZERO), X(KPP_NVAR), sum
+
+      DO i=1,NVAR
+         DO j = LU_CROW(i), LU_DIAG(i)-1 
+             X(i) = X(i) - JVS(j)*X(LU_ICOL(j));
+	 END DO  
+      END DO
+
+      DO i=NVAR,1,-1
+        sum = X(i);
+        DO j = LU_DIAG(i)+1, LU_CROW(i+1)-1
+          sum = sum - JVS(j)*X(LU_ICOL(j));
+	END DO
+        X(i) = sum/JVS(LU_DIAG(i));
+      END DO
+      
+      RETURN
+      END
